class BotServer extends TcpLink
	config(BotAPI);


var config int ListenPort;
var config int MaxConnections;

var string gameClass;
var bool bBound;
var config bool bDebug;

var int ConnectionCount;



// configurable delimeters for strings sent to clients
// currently of form (with multiple possible attributes):
// "type"$ib$"identifier"$ib$as$"attrname1"$ib$"attrvalue1"$ae

// as = identifies the start of an attribute
var string as;
// ae = attribute end
var string ae;
// ib = item break
var string ib;



//shouldn't happen
event ReceivedText( string Text )
{
    if(bDebug)
    	log("RecievedTest in Server - "$Text);
}



function BeginPlay()
{
	Super.BeginPlay();
    if(!bBound)
    {
		BindPort( ListenPort );
		if(bDebug)
    		log("BotServer bound to port "$ListenPort);
		Listen();
        bBound = true;
    }
}

//should never happen - accepted connections should be forwarded to a botconnection
event Accepted()
{
    if(bDebug)
    	log("Accepted connection in BotServer");
}

//called everytime a new botconnection is spawned
event GainedChild( Actor C )
{
	Super.GainedChild(C);
	ConnectionCount++;

    //BotConnection(C).Parent = self;
	// if too many connections, close down listen.
	if(MaxConnections > 0 && ConnectionCount > MaxConnections && LinkState == STATE_Listening)
	{
		if(bDebug)
    		Log("BotServer: Too many connections - closing down Listen.");
		Close();
	}
}

event LostChild( Actor C )
{
	Super.LostChild(C);
	ConnectionCount--;

	// if closed due to too many connections, start listening again.
	if(ConnectionCount <= MaxConnections && LinkState != STATE_Listening)
	{
		if(bDebug)
    		Log("BotServer: Listening again - connections have been closed.");
		Listen();
	}
}

defaultproperties
{
     ListenPort=3000
     MaxConnections=64
     as="{"
     ae="}"
     ib=" "
     AcceptClass=Class'BotAPI.BotConnection'
}
