/* AIBO robot
 * by Marco Zaratti - marco.zaratti@gmail.com
*/
class ERS extends KRobot config(USAR);

var int loAngleLimit[15];
var int hiAngleLimit[15];

function ProcessCarInput()
{
	local int nJoints;

	Super.ProcessCarInput();

	//Limit joints order 0 angles
	for(nJoints=0; nJoints < JointsControl.length; nJoints++)
		if((JointsControl[nJoints].state == 1) && (JointsControl[nJoints].order == 0))
		{
			if(JointsControl[nJoints].value < loAngleLimit[nJoints])
			{
				JointsControl[nJoints].value = loAngleLimit[nJoints];
				continue;
			}
			if(JointsControl[nJoints].value > hiAngleLimit[nJoints])
				JointsControl[nJoints].value = hiAngleLimit[nJoints];
		}
}

defaultproperties
{
	bDebug=false
	MaxNetUpdateInterval=0.5

	//Low Joint Angle Limits
	loAngleLimit(0)=-21845
	loAngleLimit(1)=-2730
	loAngleLimit(2)=-5461
	loAngleLimit(3)=-24576
	loAngleLimit(4)=-2730
	loAngleLimit(5)=-5461
	loAngleLimit(6)=-21845
	loAngleLimit(7)=-2730
	loAngleLimit(8)=-5461
	loAngleLimit(9)=-24576
	loAngleLimit(10)=-2730
	loAngleLimit(11)=-5461
	loAngleLimit(12)=-14563
	loAngleLimit(13)=-16930
	loAngleLimit(14)=-3640
	//High Joint Angle Limits
	hiAngleLimit(0)=24576
	hiAngleLimit(1)=16930
	hiAngleLimit(2)=23119
	hiAngleLimit(3)=21845
	hiAngleLimit(4)=16930
	hiAngleLimit(5)=23119
	hiAngleLimit(6)=24576
	hiAngleLimit(7)=16930
	hiAngleLimit(8)=23119
	hiAngleLimit(9)=21845
	hiAngleLimit(10)=16930
	hiAngleLimit(11)=23119
	hiAngleLimit(12)=546
	hiAngleLimit(13)=16930
	hiAngleLimit(14)=9102

	StaticMesh=StaticMesh'RobotSoccerStatic.ERS.Body'

    //Parameters of chassis. (KMass is defined in USAR.INI)
    Begin Object Class=KarmaParams Name=KParams0
        KStartEnabled=True
        bKDoubleTickRate=True
        bHighDetailOnly=False
        bClientOnly=False
        bKNonSphericalInertia=true
//Uncomment and define these when using RBfull karma params
//        KInertiaTensor(0)=0.4
//        KInertiaTensor(1)=0
//        KInertiaTensor(2)=0
//        KInertiaTensor(3)=0.4
//        KInertiaTensor(4)=0
//        KInertiaTensor(5)=0.4
//        KCOMOffset=(X=0.0,Y=0.0,Z=0.0)
        KLinearDamping=0.000000
        KAngularDamping=0.000000
        KFriction=0.8
        KRestitution=0.0
        Name="KParams0"
    End Object
    KParams=KarmaParams'KParams0'

}
