class ExpPath extends Object config(ExpPath);

var config array<int> path;
var int next;
var int offX;
var int offY;
var float scaleX;
var float scaleY;

function int getValue(int i) {
	if (i>path.length) i=i%path.length;
	return path[i];
}

function int nextValue() {
	next+=1;
	if (next>=path.length) next=0;
	return path[next];
}

function setOffset(int x0, int y0) {
	offX=x0;
	offY=y0;
}

function setScale(int w, int h) {
	local int i,mx,my;
	for (i=0;i<path.length;i+=2) {
		if (mx<abs(path[i]-path[0])) mx=abs(path[i]-path[0]);
		if (my<abs(path[i+1]-path[1])) my=abs(path[i+1]-path[1]);
	}
	if (mx>0) scaleX=w/((mx+offX-path[0])*2.0);
	if (my>0) scaleY=h/((mx+offX-path[1])*2.0);
}

function nextPoint(out int X, out int Y) {
	X=(nextValue()-path[0])*scaleX+offX;
	Y=(nextValue()-path[1])*scaleY+offY;
}

function dump() {
	local int i;
	log("<<<dump");
	log("offX="$offX@"offY="$offY);
	log("scaleX="$scaleX@"scaleY="$scaleY);
	for (i=0;i<path.length;i+=2) log("("$path[i]@path[i+1]$")");
	log("dump>>>");
}

defaultproperties {
	next=-1
	offX=0
	offY=0
	scaleX=1.0
	scaleY=1.0
	path(0)=0
	path(1)=10
	path(2)=0
	path(3)=20
}