class INUSensor extends sensor config (USAR);

//The class implements an Inertial Navigation Unit - it returns Roll, Pitch and Yaw
//with a bounded error superimposed on it

var USARRemoteBot rBot;

var config float ScanInterval;

var string compassData;
var Rotator iniRot;

simulated function PostNetBeginPlay()
{
	Super.PostNetBeginPlay();
	compassData="";
	if (ScanInterval>0.0)
		SetTimer(ScanInterval,true);
}

function Init(String SName, Actor parent, vector position, rotator direction, KVehicle platform, name mount)
{
	Super.Init(SName, parent, position, direction, platform, mount);

	iniRot = base.Rotation;
}

function timer()
{
	local rotator dif;
	compassData="";

	dif = base.Rotation-iniRot;
	dif.roll += RandRange(-Noise, Noise)*dif.roll;
	dif.pitch += RandRange(-Noise, Noise)*dif.pitch;
	dif.yaw += RandRange(-Noise, Noise)*dif.yaw;

    if (converter!=None) {
	    compassData="{Orientation "$converter.Str_AngleFromUU(dif.roll)
                               $","$converter.Str_AngleFromUU(dif.pitch)
                               $","$converter.Str_AngleFromUU(dif.yaw)$"}";
    } else
	compassData="{Orientation "$dif.roll$","$dif.pitch$","$dif.yaw$"}";
}

function string Set(String opcode, String args)
{
	if(Caps(opcode)=="RESET" && Caps(args)=="1") {
		iniRot = base.Rotation;
		compassData="{Orientation 0,0,0}";
		return "OK";
	}
	return "Failed";
}

function String GetData()
{
	local string outstring;

	if (ScanInterval==0.0) timer();
	if (compassData == "") return "";

	outstring = "{Name "$ItemName$"} "$compassData;
	compassData = "";

	return outstring;
}

function String GetConfData()
{
    local string outstring;
	outstring = Super.GetConfData();
	outstring = outstring@"{ScanInterval "$ScanInterval$"}";
	return outstring;
}

defaultproperties
{
	ItemType="INU"
	HiddenSensor=true
	ScanInterval=0.5
	Noise=0.01
	DrawScale=0.2
	StaticMesh=StaticMesh'USAR_Mesh.Sensor.Sensor'
	Mass=0.1

}
