class RobotCamera extends Sensor config (USAR);

var config float CameraDefFov, CameraMinFov, CameraMaxFov;

var int degCameraDefFov, degCameraMinFov, degCameraMaxFov, CameraFov;

replication
{
	reliable if(Role == ROLE_Authority) CameraFov;
}

function ConvertParam(USARConverter converter)
{
    if (converter!=NONE) {
        degCameraDefFov = converter.AngleToDeg(CameraDefFov);
        degCameraMinFov = converter.AngleToDeg(CameraMinFov);
        degCameraMaxFov = converter.AngleToDeg(CameraMaxFov);
    } else {
        degCameraDefFov = CameraDefFov;
        degCameraMinFov = CameraMinFov;
        degCameraMaxFov = CameraMaxFov;
    }
    CameraFov = degCameraDefFov;
}

function String GetData()
{
	return "";
}

function string Set(String opcode, String args)
{
	local int zoom;
	
	if (Caps(opcode)=="ZOOM") {
		zoom=converter.AngleToDeg(Float(args));
		if (Zoom>degCameraMaxFov)
			CameraFov = degCameraMaxFov;
		else if (zoom<degCameraMinFov)
			CameraFov = degCameraMinFov;
		else if (zoom==0)
			CameraFov = degCameraDefFov;
		else
			CameraFov = zoom;
		return "OK";
	}
	return "Failed";
}

simulated function setFov(int CameraZoom)
{
	CameraFov = CameraZoom;
}

simulated function int getFov()
{
	return CameraFov;
}

function String GetConfData()
{
    local string outstring;
	outstring = Super.GetConfData();
	outstring = outstring@"{CameraDefFov "$converter.FloatString(CameraDefFov)$"}"@
	                      "{CameraMinFov "$converter.FloatString(CameraMinFov)$"}"@
	                      "{CameraMaxFov "$converter.FloatString(CameraMaxFov)$"}"@
	                      "{CameraFov "$converter.Str_AngleFromDeg(CameraFov)$"}";
	return outstring;
}

defaultproperties
{
	ItemType="Camera"
	CameraDefFov=0.8727 // 50 deg
	CameraMinFov=0.3491 // 20 deg
	CameraMaxFov=1.7453 // 100 deg
	RemoteRole=ROLE_SimulatedProxy
}
