// ===============================================================
// USARBot.VictRFIDTag
//
// Created by Mentar Mahmudi, International University Bremen Feb 05 2006
// ===============================================================

class VictRFIDTag extends Actor placeable;

var () int id;
var () string name;

// Register to the game
function Register()
{
	local USARDeathMatch UsarGame;
	local int Index;

	UsarGame = USARDeathMatch(Level.Game);
	Index = UsarGame.VictRFIDTags.length;
	UsarGame.VictRFIDTags.Insert(Index, 1);
	UsarGame.VictRFIDTags[Index] = self;
}

// Unregister from the game
function Unregister()
{
	local USARDeathMatch UsarGame;
	local int i;

	UsarGame = USARDeathMatch(Level.Game);
	for (i = 0; i < UsarGame.VictRFIDTags.length; i++) {
		if (UsarGame.VictRFIDTags[i] == self) {
			UsarGame.VictRFIDTags.Remove(i, 1);
			break;
		}
	}
}

simulated function PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	Register();
}

simulated event Destroyed()
{
	Unregister();
	Super.Destroyed();
}

defaultproperties
{
	DrawType=DT_StaticMesh
	StaticMesh=StaticMesh'Editor.TexPropCube'
	DrawScale3D=(X=0.01,Y=0.01,Z=0.002)
	bStatic=False
	bStasis=False
}
